diff -uwr sourceold/scripts/scripts.vcxproj source/scripts/scripts.vcxproj
--- sourceold/scripts/scripts.vcxproj	2012-03-06 21:47:37.583984300 +0800
+++ source/scripts/scripts.vcxproj	2012-06-09 08:11:12.138671800 +0800
@@ -261,7 +261,7 @@
       <MinimalRebuild>false</MinimalRebuild>
       <ExceptionHandling>
       </ExceptionHandling>
-      <RuntimeLibrary>MultiThreadedDLL</RuntimeLibrary>
+      <RuntimeLibrary>MultiThreadedDebugDLL</RuntimeLibrary>
       <BufferSecurityCheck>false</BufferSecurityCheck>
       <FunctionLevelLinking>true</FunctionLevelLinking>
       <EnableEnhancedInstructionSet>NotSet</EnableEnhancedInstructionSet>
@@ -338,7 +338,7 @@
       <MinimalRebuild>false</MinimalRebuild>
       <ExceptionHandling>
       </ExceptionHandling>
-      <RuntimeLibrary>MultiThreadedDLL</RuntimeLibrary>
+      <RuntimeLibrary>MultiThreadedDebugDLL</RuntimeLibrary>
       <BufferSecurityCheck>false</BufferSecurityCheck>
       <FunctionLevelLinking>true</FunctionLevelLinking>
       <EnableEnhancedInstructionSet>NotSet</EnableEnhancedInstructionSet>
@@ -387,6 +387,7 @@
     </PostBuildEvent>
   </ItemDefinitionGroup>
   <ItemGroup>
+    <ClCompile Include="aow_intruders.cpp" />
     <ClCompile Include="cAMpaScripts.cpp" />
     <ClCompile Include="CommandLineParser.cpp" />
     <ClCompile Include="Crc32.cpp" />
@@ -463,6 +464,7 @@
     <ClCompile Include="jmgrp2.cpp" />
     <ClCompile Include="kak.cpp" />
     <ClCompile Include="kamuix.cpp" />
+    <ClCompile Include="LoopedAnimationController.cpp" />
     <ClCompile Include="mdb.cpp" />
     <ClCompile Include="mdbdef.cpp" />
     <ClCompile Include="mdbevf.cpp" />
@@ -493,21 +495,30 @@
     <ClCompile Include="tcw_coop_cruising.cpp" />
     <ClCompile Include="tcw_defence.cpp" />
     <ClCompile Include="tcw_domination.cpp" />
+    <ClCompile Include="tcw_frost.cpp" />
+    <ClCompile Include="tcw_functions.cpp" />
     <ClCompile Include="tcw_game.cpp" />
+    <ClCompile Include="tcw_general.cpp" />
+    <ClCompile Include="tcw_mcv_escort.cpp" />
     <ClCompile Include="tcw_player.cpp" />
     <ClCompile Include="tcw_powerup.cpp" />
+    <ClCompile Include="tcw_raid_at_dawn.cpp" />
     <ClCompile Include="tcw_superweapons.cpp" />
+    <ClCompile Include="tcw_TCWSoldierObj.cpp" />
     <ClCompile Include="tcw_technology.cpp" />
+    <ClCompile Include="tcw_tiberium.cpp" />
     <ClCompile Include="tcw_vehicle.cpp" />
     <ClCompile Include="tcw_zone.cpp" />
     <ClCompile Include="tda.cpp" />
     <ClCompile Include="tfx.cpp" />
     <ClCompile Include="ThreadClass.cpp" />
     <ClCompile Include="z.cpp" />
+    <ClCompile Include="z_airraid.cpp" />
     <ClCompile Include="z_am01.cpp" />
     <ClCompile Include="z_am02.cpp" />
     <ClCompile Include="z_buildingrevive.cpp" />
     <ClCompile Include="z_cargo.cpp" />
+    <ClCompile Include="z_center_point.cpp" />
     <ClCompile Include="z_cold_fever.cpp" />
     <ClCompile Include="z_coop.cpp" />
     <ClCompile Include="z_darkdawn.cpp" />
@@ -546,10 +557,14 @@
     <ClCompile Include="z_lockdown.cpp" />
     <ClCompile Include="z_m00.cpp" />
     <ClCompile Include="z_m01.cpp" />
+    <ClCompile Include="z_mediterranean.cpp" />
+    <ClCompile Include="z_misc.cpp" />
     <ClCompile Include="z_nod_invasion.cpp" />
+    <ClCompile Include="z_prototype.cpp" />
     <ClCompile Include="z_reconnaissance.cpp" />
     <ClCompile Include="z_ship.cpp" />
     <ClCompile Include="z_siege.cpp" />
+    <ClCompile Include="z_tropical.cpp" />
     <ClCompile Include="z_uberaow.cpp" />
     <ClCompile Include="z_zones.cpp" />
   </ItemGroup>
@@ -563,6 +578,7 @@
     <ClInclude Include="AirFactoryGameObjDef.h" />
     <ClInclude Include="AirStripGameObj.h" />
     <ClInclude Include="AirStripGameObjDef.h" />
+    <ClInclude Include="aow_intruders.h" />
     <ClInclude Include="ArmedGameObj.h" />
     <ClInclude Include="ArmedGameObjDef.h" />
     <ClInclude Include="ArmorWarheadManager.h" />
@@ -580,6 +596,7 @@
     <ClInclude Include="cAMpaScripts.h" />
     <ClInclude Include="CinematicGameObj.h" />
     <ClInclude Include="CinematicGameObjDef.h" />
+    <ClInclude Include="cNetEvent.h" />
     <ClInclude Include="CollisionMath.h" />
     <ClInclude Include="coltest.h" />
     <ClInclude Include="coltype.h" />
@@ -592,6 +609,8 @@
     <ClInclude Include="ConPublic.h" />
     <ClInclude Include="cPlayer.h" />
     <ClInclude Include="Crc32.h" />
+    <ClInclude Include="cScTextObj.h" />
+    <ClInclude Include="cTeam.h" />
     <ClInclude Include="CullSystemClass.h" />
     <ClInclude Include="DamageableGameObj.h" />
     <ClInclude Include="DamageableGameObjDef.h" />
@@ -690,11 +709,14 @@
     <ClInclude Include="jmgrp2.h" />
     <ClInclude Include="kak.h" />
     <ClInclude Include="kamuix.h" />
+    <ClInclude Include="LoopedAnimationController.h" />
     <ClInclude Include="mdb.h" />
     <ClInclude Include="mdbdef.h" />
     <ClInclude Include="mdbevf.h" />
     <ClInclude Include="MixFileFactoryClass.h" />
     <ClInclude Include="MoveablePhysDefClass.h" />
+    <ClInclude Include="NavalFactoryGameObj.h" />
+    <ClInclude Include="NavalFactoryGameObjDef.h" />
     <ClInclude Include="neo.h" />
     <ClInclude Include="NetworkObjectClass.h" />
     <ClInclude Include="nh.h" />
@@ -734,6 +756,7 @@
     <ClInclude Include="SamSiteGameObjDef.h" />
     <ClInclude Include="SaveLoadSubSystemClass.h" />
     <ClInclude Include="SaveLoadSystemClass.h" />
+    <ClInclude Include="SCAnnouncement.h" />
     <ClInclude Include="SceneClass.h" />
     <ClInclude Include="ScriptableGameObj.h" />
     <ClInclude Include="ScriptableGameObjDef.h" />
@@ -765,11 +788,18 @@
     <ClInclude Include="tcw_coop_cruising.h" />
     <ClInclude Include="tcw_defence.h" />
     <ClInclude Include="tcw_domination.h" />
+    <ClInclude Include="tcw_frost.h" />
+    <ClInclude Include="tcw_functions.h" />
     <ClInclude Include="tcw_game.h" />
+    <ClInclude Include="tcw_general.h" />
+    <ClInclude Include="tcw_mcv_escort.h" />
     <ClInclude Include="tcw_player.h" />
     <ClInclude Include="tcw_powerup.h" />
+    <ClInclude Include="tcw_raid_at_dawn.h" />
     <ClInclude Include="tcw_superweapons.h" />
+    <ClInclude Include="tcw_TCWSoldierObj.h" />
     <ClInclude Include="tcw_technology.h" />
+    <ClInclude Include="tcw_tiberium.h" />
     <ClInclude Include="tcw_vehicle.h" />
     <ClInclude Include="tcw_zone.h" />
     <ClInclude Include="tda.h" />
@@ -792,10 +822,12 @@
     <ClInclude Include="WidgetUserClass.h" />
     <ClInclude Include="WWAudioClass.h" />
     <ClInclude Include="z.h" />
+    <ClInclude Include="z_airraid.h" />
     <ClInclude Include="z_am01.h" />
     <ClInclude Include="z_am02.h" />
     <ClInclude Include="z_buildingrevive.h" />
     <ClInclude Include="z_cargo.h" />
+    <ClInclude Include="z_center_point.h" />
     <ClInclude Include="z_cold_fever.h" />
     <ClInclude Include="z_coop.h" />
     <ClInclude Include="z_darkdawn.h" />
@@ -886,10 +918,14 @@
     <ClInclude Include="z_lockdown.h" />
     <ClInclude Include="z_m00.h" />
     <ClInclude Include="z_m01.h" />
+    <ClInclude Include="z_mediterranean.h" />
+    <ClInclude Include="z_misc.h" />
     <ClInclude Include="z_nod_invasion.h" />
+    <ClInclude Include="z_prototype.h" />
     <ClInclude Include="z_reconnaissance.h" />
     <ClInclude Include="z_ship.h" />
     <ClInclude Include="z_siege.h" />
+    <ClInclude Include="z_tropical.h" />
     <ClInclude Include="z_uberaow.h" />
     <ClInclude Include="z_zones.h" />
   </ItemGroup>
diff -uwr sourceold/scripts/scripts.vcxproj.filters source/scripts/scripts.vcxproj.filters
--- sourceold/scripts/scripts.vcxproj.filters	2012-03-06 21:47:37.586914000 +0800
+++ source/scripts/scripts.vcxproj.filters	2012-06-09 08:11:12.155273400 +0800
@@ -458,9 +458,6 @@
     <ClCompile Include="tcw_coop_cruising.cpp">
       <Filter>01. Sources\Tib. Crystal War</Filter>
     </ClCompile>
-    <ClCompile Include="tcw_defence.cpp">
-      <Filter>01. Sources\Tib. Crystal War</Filter>
-    </ClCompile>
     <ClCompile Include="tcw_zone.cpp">
       <Filter>01. Sources\Tib. Crystal War</Filter>
     </ClCompile>
@@ -473,6 +470,54 @@
     <ClCompile Include="z_domination.cpp">
       <Filter>01. Sources</Filter>
     </ClCompile>
+    <ClCompile Include="z_mediterranean.cpp">
+      <Filter>01. Sources</Filter>
+    </ClCompile>
+    <ClCompile Include="z_tropical.cpp">
+      <Filter>01. Sources</Filter>
+    </ClCompile>
+    <ClCompile Include="z_prototype.cpp">
+      <Filter>01. Sources</Filter>
+    </ClCompile>
+    <ClCompile Include="z_center_point.cpp">
+      <Filter>01. Sources</Filter>
+    </ClCompile>
+    <ClCompile Include="z_airraid.cpp">
+      <Filter>01. Sources</Filter>
+    </ClCompile>
+    <ClCompile Include="z_misc.cpp">
+      <Filter>01. Sources</Filter>
+    </ClCompile>
+    <ClCompile Include="aow_intruders.cpp">
+      <Filter>01. Sources\UberAOW</Filter>
+    </ClCompile>
+    <ClCompile Include="tcw_frost.cpp">
+      <Filter>01. Sources\Tib. Crystal War</Filter>
+    </ClCompile>
+    <ClCompile Include="tcw_functions.cpp">
+      <Filter>01. Sources\Tib. Crystal War</Filter>
+    </ClCompile>
+    <ClCompile Include="tcw_general.cpp">
+      <Filter>01. Sources\Tib. Crystal War</Filter>
+    </ClCompile>
+    <ClCompile Include="tcw_TCWSoldierObj.cpp">
+      <Filter>01. Sources\Tib. Crystal War</Filter>
+    </ClCompile>
+    <ClCompile Include="tcw_tiberium.cpp">
+      <Filter>01. Sources\Tib. Crystal War</Filter>
+    </ClCompile>
+    <ClCompile Include="tcw_raid_at_dawn.cpp">
+      <Filter>01. Sources\Tib. Crystal War</Filter>
+    </ClCompile>
+    <ClCompile Include="tcw_defence.cpp">
+      <Filter>01. Sources\Tib. Crystal War</Filter>
+    </ClCompile>
+    <ClCompile Include="LoopedAnimationController.cpp">
+      <Filter>01. Sources</Filter>
+    </ClCompile>
+    <ClCompile Include="tcw_mcv_escort.cpp">
+      <Filter>01. Sources\Tib. Crystal War</Filter>
+    </ClCompile>
   </ItemGroup>
   <ItemGroup>
     <ResourceCompile Include="scripts.rc">
@@ -1416,9 +1461,6 @@
     <ClInclude Include="tcw_coop_cruising.h">
       <Filter>02. Headers\Tib. Crystal War</Filter>
     </ClInclude>
-    <ClInclude Include="tcw_defence.h">
-      <Filter>02. Headers\Tib. Crystal War</Filter>
-    </ClInclude>
     <ClInclude Include="ScriptManager.h">
       <Filter>03. New Sources</Filter>
     </ClInclude>
@@ -1431,6 +1473,72 @@
     <ClInclude Include="z_domination.h">
       <Filter>02. Headers</Filter>
     </ClInclude>
+    <ClInclude Include="NavalFactoryGameObjDef.h">
+      <Filter>03. New Sources</Filter>
+    </ClInclude>
+    <ClInclude Include="NavalFactoryGameObj.h">
+      <Filter>03. New Sources</Filter>
+    </ClInclude>
+    <ClInclude Include="z_mediterranean.h">
+      <Filter>02. Headers</Filter>
+    </ClInclude>
+    <ClInclude Include="z_tropical.h">
+      <Filter>02. Headers</Filter>
+    </ClInclude>
+    <ClInclude Include="z_prototype.h">
+      <Filter>02. Headers</Filter>
+    </ClInclude>
+    <ClInclude Include="z_center_point.h">
+      <Filter>02. Headers</Filter>
+    </ClInclude>
+    <ClInclude Include="z_airraid.h">
+      <Filter>02. Headers</Filter>
+    </ClInclude>
+    <ClInclude Include="z_misc.h">
+      <Filter>02. Headers</Filter>
+    </ClInclude>
+    <ClInclude Include="aow_intruders.h">
+      <Filter>02. Headers\UberAOW</Filter>
+    </ClInclude>
+    <ClInclude Include="SCAnnouncement.h">
+      <Filter>02. Headers</Filter>
+    </ClInclude>
+    <ClInclude Include="cNetEvent.h">
+      <Filter>02. Headers</Filter>
+    </ClInclude>
+    <ClInclude Include="cScTextObj.h">
+      <Filter>02. Headers</Filter>
+    </ClInclude>
+    <ClInclude Include="tcw_frost.h">
+      <Filter>02. Headers\Tib. Crystal War</Filter>
+    </ClInclude>
+    <ClInclude Include="tcw_functions.h">
+      <Filter>02. Headers\Tib. Crystal War</Filter>
+    </ClInclude>
+    <ClInclude Include="tcw_general.h">
+      <Filter>02. Headers\Tib. Crystal War</Filter>
+    </ClInclude>
+    <ClInclude Include="tcw_raid_at_dawn.h">
+      <Filter>02. Headers\Tib. Crystal War</Filter>
+    </ClInclude>
+    <ClInclude Include="tcw_TCWSoldierObj.h">
+      <Filter>02. Headers\Tib. Crystal War</Filter>
+    </ClInclude>
+    <ClInclude Include="tcw_tiberium.h">
+      <Filter>02. Headers\Tib. Crystal War</Filter>
+    </ClInclude>
+    <ClInclude Include="tcw_defence.h">
+      <Filter>02. Headers\Tib. Crystal War</Filter>
+    </ClInclude>
+    <ClInclude Include="LoopedAnimationController.h">
+      <Filter>02. Headers</Filter>
+    </ClInclude>
+    <ClInclude Include="cTeam.h">
+      <Filter>03. New Sources</Filter>
+    </ClInclude>
+    <ClInclude Include="tcw_mcv_escort.h">
+      <Filter>02. Headers\Tib. Crystal War</Filter>
+    </ClInclude>
   </ItemGroup>
   <ItemGroup>
     <None Include="console.txt">
diff -uwr sourceold/scripts/sh_blocker.cpp source/scripts/sh_blocker.cpp
--- sourceold/scripts/sh_blocker.cpp	2011-10-11 23:06:19.515625000 +0800
+++ source/scripts/sh_blocker.cpp	2012-05-23 10:24:00.880859300 +0800
@@ -51,6 +51,8 @@
 		// base implementation
 		ScriptImpClass::Detach(obj);
 
+		if (Exe != 4) //make sure we dont try things in LE that may cause issues
+		{
 		// pull out the physical_obj
 		PhysicalGameObj* physical_obj = obj->As_PhysicalGameObj();
 
@@ -65,6 +67,7 @@
 
 		// inform netcode of the dirty things we've done with the phys
 		physical_obj->Set_Object_Dirty_Bit(NetworkObjectClass::BIT_RARE, true);
+		}
 	};
 };
 
diff -uwr sourceold/scripts/sh_underground.cpp source/scripts/sh_underground.cpp
--- sourceold/scripts/sh_underground.cpp	2011-10-11 23:06:17.741210900 +0800
+++ source/scripts/sh_underground.cpp	2012-05-23 10:23:59.060546800 +0800
@@ -257,8 +257,11 @@
 
 	void Detach(GameObject* obj)
 	{
+		if (Exe != 4) //make sure we dont try things in LE that may cause issues
+		{
 		// force exit of underground (don't want any objects stuck underground)
 		ExitUndergroundMode(true);
+		}
 
 		// base implementation
 		ScriptImpClass::Detach(obj);
Only in source/scripts: tcw_TCWSoldierObj.cpp
Only in source/scripts: tcw_TCWSoldierObj.h
diff -uwr sourceold/scripts/tcw_building.cpp source/scripts/tcw_building.cpp
--- sourceold/scripts/tcw_building.cpp	2012-02-02 09:44:43.142578100 +0800
+++ source/scripts/tcw_building.cpp	2012-06-09 08:11:12.324218700 +0800
@@ -1,5 +1,5 @@
 /*	Renegade Scripts.dll
-	Scripts by zunnie - http://www.tiberiumcrystalwar.com
+	Scripts from - http://www.tiberiumcrystalwar.com
 	Copyright 2011-2012 MPF
 
 	This file is part of the Renegade scripts.dll
@@ -14,6 +14,7 @@
 #include "general.h"
 #include "scripts.h"
 #include "engine.h"
+#include "buildinggameobj.h"
 #include "tcw_building.h"
 
 void tcw_building::Created(GameObject *obj)
@@ -23,6 +24,7 @@
 	if (strcmp(Commands->Get_Preset_Name(obj),"TCW_GDI_Command_Post") == 0)
 	{
 		Commands->Set_Animation(obj,"V_GDI_CPOST.V_GDI_CPOST",true,0,1,-1,0);
+		Commands->Start_Timer(obj,this,300.0f,111222);//radar scan
 	}
 }
 void tcw_building::Killed(GameObject *obj, GameObject *shooter)
@@ -48,9 +50,9 @@
 	}
 	else if (strcmp(Commands->Get_Preset_Name(obj),"TCW_Nod_War_Factory") == 0)
 	{
-		Create_2D_WAV_Sound_Team("nod_warfactory_destroyed_nod.wav",1);
+		Create_2D_WAV_Sound_Team("nod_warfactory_destroyed_gdi.wav",1);
 		Create_2D_WAV_Sound_Team("nod_warfactory_destroyed_nod.wav",0);
-		Send_Message(255,255,255,"Nod Weapons Factory destroyed.");
+		Send_Message(255,255,255,"Nod War Factory destroyed.");
 	}
 	else if (strcmp(Commands->Get_Preset_Name(obj),"TCW_Hand_Of_Nod") == 0)
 	{
@@ -76,7 +78,7 @@
 		Create_2D_WAV_Sound_Team("nod_powerplant_destroyed_nod.wav",0);
 		Send_Message_Team(1,255,255,255,"Nod Power Plant destroyed.");
 		Send_Message_Team(0,255,255,255,"Nod Power Plant destroyed.");
-		if (Find_Building_By_Name(0,"TCW_Nod_Oper_Centre"))
+		if (Find_Building_By_Preset(0,"TCW_Nod_Oper_Centre"))
 		{
 			Enable_Base_Radar(0,false);
 			Create_2D_WAV_Sound_Team("radar_off.wav",0);
@@ -88,11 +90,13 @@
 		Create_2D_WAV_Sound_Team("gdi_powerplant_destroyed_nod.wav",0);
 		Send_Message_Team(1,255,255,255,"GDI Power Plant destroyed.");
 		Send_Message_Team(0,255,255,255,"GDI Power Plant destroyed.");
-		if (Find_Building_By_Name(1,"TCW_GDI_Command_Post"))
+		if (Find_Building_By_Preset(1,"TCW_GDI_Command_Post"))
 		{
 			Enable_Base_Radar(1,false);
 			Create_2D_WAV_Sound_Team("radar_off.wav",1);
+			Send_Message_Team(1,255,255,255,"Command Post Radar Scans cancelled");
 		}
+		Send_Message_Team(1,255,255,255,"Vehicle Factory Unit build times tripled");
 	}
 	else if (strcmp(Commands->Get_Preset_Name(obj),"TCW_Nod_Airfield") == 0)
 	{
@@ -107,6 +111,9 @@
 		Commands->Set_Animation(obj,"V_GDI_CPOST.V_GDI_CPOST",true,0,1,1,0);
 		Enable_Base_Radar(1,false);
 		Create_2D_WAV_Sound_Team("radar_off.wav",1);
+		Create_2D_WAV_Sound_Team("gdi_command_post_destroyed_nod.wav",0);
+		Create_2D_WAV_Sound_Team("gdi_command_post_destroyed_gdi.wav",1);
+		Send_Message(255,255,255,"Command Post Radar Scans cancelled");
 	}
 	else if (strcmp(Commands->Get_Preset_Name(obj),"TCW_VehBld_Nod_OpCtr") == 0)
 	{
@@ -118,10 +125,12 @@
 	else if (strcmp(Commands->Get_Preset_Name(obj),"TCW_VehBld_GDI_Armory") == 0)
 	{
 		Send_Message(255,255,255,"GDI Armory destroyed.");
+		Create_2D_WAV_Sound_Team("gdi_armory_destroyed_gdi.wav",1);
 	}
 	else if (strcmp(Commands->Get_Preset_Name(obj),"TCW_VehBld_Nod_Silo") == 0)
 	{
 		Create_2D_WAV_Sound_Team("nod_tiberium_silo_destroyed_nod.wav",0);
+		Create_2D_WAV_Sound_Team("nod_tiberium_silo_destroyed_gdi.wav",1);
 		Send_Message(255,255,255,"Nod Tiberium Silo destroyed.");
 	}
 	else if (strcmp(Commands->Get_Preset_Name(obj),"TCW_VehBld_GDI_Silo") == 0)
@@ -140,6 +149,10 @@
 		Create_2D_WAV_Sound_Team("nod_temple_destroyed_nod.wav",0);
 		Create_2D_WAV_Sound_Team("nod_temple_destroyed_gdi.wav",1);
 	}
+	else if (strcmp(Commands->Get_Preset_Name(obj),"TCW_VehBld_Nod_Shrine") == 0)
+	{
+		Send_Message(255,255,255,"Shrine of Nod destroyed.");
+	}
 }
 void tcw_building::Damaged(GameObject *obj, GameObject *damager, float damage)
 {
@@ -174,10 +187,10 @@
 				}
 				else if (strcmp(Commands->Get_Preset_Name(obj),"TCW_Nod_War_Factory") == 0)
 				{
-					Create_2D_WAV_Sound_Team("nod_warfactory_under_attack_nod.wav",1);
+					Create_2D_WAV_Sound_Team("nod_warfactory_under_attack_gdi.wav",1);
 					Create_2D_WAV_Sound_Team("nod_warfactory_under_attack_nod.wav",0);
-					Send_Message_Team(0,255,255,255,"Warning Nod Weapons Factory under attack.");
-					Send_Message_Team(1,255,255,255,"Nod Weapons Factory under attack.");
+					Send_Message_Team(0,255,255,255,"Warning Nod War Factory under attack.");
+					Send_Message_Team(1,255,255,255,"Nod War Factory under attack.");
 				}
 				else if ( (strcmp(Commands->Get_Preset_Name(obj),"TCW_Nod_Refinery") == 0) || (strcmp(Commands->Get_Preset_Name(obj),"TCW_Nod_Refinery_Blue") == 0) )
 				{
@@ -228,16 +241,25 @@
 					Send_Message_Team(0,255,255,255,"Warning Nod Air Control Tower under attack.");
 					Send_Message_Team(1,255,255,255,"Nod Airfield under attack.");
 				}
-				else if ( (strcmp(Commands->Get_Preset_Name(obj),"TCW_VehBld_GDI_Armory") == 0) ||
-					(strcmp(Commands->Get_Preset_Name(obj),"TCW_VehBld_GDI_Silo") == 0) )
+				else if (strcmp(Commands->Get_Preset_Name(obj),"TCW_VehBld_GDI_Armory") == 0)
+				{
+					Create_2D_WAV_Sound_Team("gdi_armory_under_attack_gdi.wav",1);
+					Send_Message_Team(1,255,255,255,"Warning GDI Armory under attack.");
+					Send_Message_Team(0,255,255,255,"GDI Armory under attack.");
+				}
+				else if (strcmp(Commands->Get_Preset_Name(obj),"TCW_VehBld_GDI_Silo") == 0)
 				{
 					Create_2D_WAV_Sound_Team("gdi_our_base_under_attack.wav",1);
-					Send_Message_Team(1,255,255,255,"Our Base is under attack.");
+					Send_Message_Team(1,255,255,255,"Our Base is under attack. (Tiberium Silo)");
+					Send_Message_Team(0,255,255,255,"GDI Tiberium Silo under attack.");
 				}
 				else if (strcmp(Commands->Get_Preset_Name(obj),"TCW_VehBld_GDI_CmdPost") == 0)
 				{
+					Create_2D_WAV_Sound_Team("gdi_command_post_under_attack_nod.wav",0);
+					Send_Message_Team(0,255,255,255,"GDI Command Post under attack.");
 					Create_2D_WAV_Sound_Team("gdi_command_post_under_attack_gdi.wav",1);
 					Send_Message_Team(1,255,255,255,"Warning GDI Command Post under attack.");
+					
 				}
 				else if (strcmp(Commands->Get_Preset_Name(obj),"TCW_VehBld_Nod_OpCtr") == 0)
 				{
@@ -253,11 +275,6 @@
 					Create_2D_WAV_Sound_Team("nod_shrine_under_attack_gdi.wav",1);
 					Send_Message_Team(1,255,255,255,"Shrine of Nod under attack.");
 				}
-				else if (strcmp(Commands->Get_Preset_Name(obj),"TCW_VehBld_Nod_Silo") == 0)
-				{
-					Create_2D_WAV_Sound_Team("nod_tiberium_silo_under_attack_nod.wav",0);
-					Send_Message_Team(0,255,255,255,"Warning Nod Tiberium Silo under attack.");
-				}
 				else if (strcmp(Commands->Get_Preset_Name(obj),"TCW_VehBld_GDI_IonCtr") == 0)
 				{
 					Create_2D_WAV_Sound_Team("gdi_ion_center_under_attack_nod.wav",0);
@@ -272,6 +289,13 @@
 					Create_2D_WAV_Sound_Team("nod_temple_under_attack_gdi.wav",1);
 					Send_Message_Team(1,255,255,255,"Temple of Nod under attack.");
 				}
+				else if (strcmp(Commands->Get_Preset_Name(obj),"TCW_VehBld_Nod_Silo") == 0)
+				{
+					Create_2D_WAV_Sound_Team("nod_tiberium_silo_under_attack_nod.wav",0);
+					Send_Message_Team(0,255,255,255,"Warning Nod Tiberium Silo under attack.");
+					Create_2D_WAV_Sound_Team("nod_tiberium_silo_under_attack_gdi.wav",1);
+					Send_Message_Team(1,255,255,255,"Nod Tiberium Silo under attack.");
+				}
 			}
 		}
 	}
@@ -285,6 +309,29 @@
 			playdamage = true;
 		}
 	}
+	else if (number == 111222)
+	{
+		if (alive)
+		{
+			if (Is_Base_Powered(1))
+			{
+				Send_Custom_Event_To_Object(obj,"TCW_Nod_Shadow",1004,1,0);
+				Send_Custom_Event_To_Object(obj,"TCW_Nod_Shadow_Low",1004,1,0);
+				Send_Custom_Event_To_Object(obj,"TCW_Nod_Stealth_Tank",1004,1,0);
+				Send_Custom_Event_To_Object(obj,"TCW_GDI_Stealth_Tank",1004,1,0);
+				Send_Custom_Event_To_Object(obj,"TCW_Nod_Harvester",1004,1,0);
+				Send_Custom_Event_To_Object(obj,"TCW_Nod_Harvester_Player",1004,1,0);
+				Send_Custom_Event_To_Object(obj,"TCW_GDI_Nod_Harvester_Player",1004,1,0);
+				Send_Custom_Event_To_Object(obj,"TCW_GDI_Sniper",1004,1,0);
+				Send_Custom_Event_To_Object(obj,"TCW_GDI_Sniper_Low",1004,1,0);
+				Send_Custom_Event_To_Object(obj,"TCW_Nod_Commando",1004,1,0);
+				Send_Custom_Event_To_Object(obj,"TCW_Nod_Commando_Low",1004,1,0);
+				Commands->Start_Timer(obj,this,300.0f,111222);//radar scan repeat
+				Send_Message(255,255,255,"GDI Command Post Radar Scan Initiated");
+				Commands->Create_2D_WAV_Sound("radarscan.wav");
+			}
+		}
+	}
 }
 void tcw_building::Custom(GameObject *obj, int message, int param, GameObject *sender)
 {
@@ -292,7 +339,7 @@
 	{ 
 		if (param == 1)
 		{
-			if (Is_ComCenter(obj))
+			if (obj && obj->As_BuildingGameObj() && obj->As_BuildingGameObj()->As_ComCenterGameObj())
 			{
 				Restore_Building(obj);
 				Commands->Set_Health(obj,Commands->Get_Max_Health(obj));
diff -uwr sourceold/scripts/tcw_building.h source/scripts/tcw_building.h
--- sourceold/scripts/tcw_building.h	2012-02-02 09:44:43.155273400 +0800
+++ source/scripts/tcw_building.h	2012-06-09 08:11:12.158203100 +0800
@@ -1,5 +1,5 @@
 /*	Renegade Scripts.dll
-	Scripts by zunnie - http://www.tiberiumcrystalwar.com
+	Scripts from - http://www.tiberiumcrystalwar.com
 	Copyright 2011-2012 MPF
 
 	This file is part of the Renegade scripts.dll
